/*  test for setjmp/longjmp
    essentially an intreprocedural goto 
    see comments below */

#include <setjmp.h>

typedef int T;
typedef int N;

jmp_buf env;

void bar() {}
void baz() 
{
  int i;

  i = 3; // bogus

  /* with longjmp, 'T bar baz' are in the effect at this point
     without longjmp, the effect is empty */
  //longjmp(env, 23);
}


void foo()
{
  T t;
  int i;

  i = setjmp(env);

  i = t;

  bar();
  baz();
}

int main(int argc, char **argv)
{
  foo();

  return 0;
}
