/* Map implementation. Stores (char * key, void * value) pairs  */
#include <stdlib.h>

#define __USE_GNU
#include <search.h>

void * mCreateMap() 
{ 
  struct hsearch_data * hd = calloc(1, sizeof(struct hsearch_data));
  
  if (hd == NULL) 
    return NULL;

  if (hcreate_r(100, hd) == 0)
    return NULL;
  else
    return hd;
}

void   mAdd(void * mapp, const char * key, void * value)
{ 
  ENTRY e, * ret;
  e.key = (char *)key;
  e.data = value;

  hsearch_r(e, ENTER, &ret, mapp);
}

void * mFind(void * mapp, const char * key)
{ 
  ENTRY e, * ret;
  e.key = (char *)key;

  if (hsearch_r(e, FIND, &ret, mapp) == 0)
    return NULL;
  else
    return ret->data;
}

void   mRemove(void * mapp, const char * key)
{
}

void   mDeleteMap(void * mapp)
{
  hdestroy_r(mapp);
}
